use std::rc::Rc;

use libopenbirch::node::{
    NodeEnum, add::Add, constant::Constant, divide::Divide, multiply::Multiply, symbol::Symbol,
};
use math_segments::MathSegment;

mod math_segments;

pub struct GUI {
    meth: Vec<Rc<dyn MathSegment>>,
}

impl GUI {
    pub fn new() -> Self {
        let a = Constant::new(69.0).into();
        let b = Constant::new(420.0).into();
        let c: NodeEnum = Add::new(a, b).into();
        let d = Symbol::new_from_str("x").into();
        let e = Divide::new(c.clone(), d).into();
        let f = Multiply::new(e, c);

        Self {
            meth: vec![Rc::new(NodeEnum::Multiply(f))],
        }
    }
}
